#include<bits/stdc++.h>
using namespace std;
long calc[1024];
long funk(int a){
	if(a==1){
		return 1;
	}
	else{
		int rez=0;
	//vector<long> divisors(a);
	for(int i=1; i<a+1; i++){
		if(a%i==0){
			//divisors.push_back(i);
			rez=rez^i;
		}
	}
	/*int k=0;
	if(a%2==0){
		while(a%2==0){
			a=a/2;
			k++;
			divisors.push_back(a);
			divisors.push_back(2*k);
		}
		
	}
	
	for(int i=3; a!=1; i++){
      while(a%i==0){
        a=a/i;
        divisors.push_back(a);
      }
    }*/
    /*for(int i=0; i<divisors.size(); i++){
    	cout<<divisors[i]<<" ";
	}*/
	
	/*for(int j=0; j<divisors.size(); j++){
		
	}*/
	return rez;
}
}
int main() {
	long n,k;
	cin>>n>>k;
	long a;
	for(int i=0; i<k; i++){
		cin>>a;
		cout<<funk(a)<<" ";
	}
	return 0;
}